// -----------------------------------------------------------------------
// Copyright (C) 2019-2024, EyeLogic GmbH
//
// Permission is hereby granted, free of charge, to any person or
// organization obtaining a copy of the software and accompanying
// documentation covered by this license (the "Software") to use,
// reproduce, display, distribute, execute, and transmit the Software,
// and to prepare derivative works of the Software, and to permit
// third-parties to whom the Software is furnished to do so.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
// NON-INFRINGEMENT. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR ANYONE
// DISTRIBUTING THE SOFTWARE BE LIABLE FOR ANY DAMAGES OR OTHER
// LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT
// OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
// -----------------------------------------------------------------------

#pragma once

#include "elapi/ELApi.h"
#include "ELGazeVisualizer.h"

class DemoClientVisualize : public elapi::ELApi::ELGazeSampleCallback,
                            public elapi::ELApi::ELGazeEventCallback,
                            public elapi::ELApi::ELDeviceEventCallback
{
public:
    DemoClientVisualize( );
    virtual ~DemoClientVisualize( );

    void STDCALL onGazeSample( const elapi::ELGazeSample& gazeSample ) override;
    void STDCALL onFixationStart( elapi::ELFixationStart fixation ) override;
    void STDCALL onFixationStop( elapi::ELFixationStop fixation ) override;
    void STDCALL onDeviceEvent( elapi::ELApi::DeviceEvent event ) override;
    void         onEscPressed( );

    int run( );

private:
    ELGazeVisualizer        m_visualizer;
    std::mutex              m_mutex;
    std::condition_variable m_cond;

    int32_t m_rawResolutionX;
    int32_t m_rawResolutionY;
};
